; 
    include \masm32\include\masm32rt.inc
    include limoalloc.asm

    PROCESS_HEAP_ENTRY STRUCT
      lpData        DWORD ?
      cbData        DWORD ?
      cbOverhead    BYTE  ?
      iRegionIndex  BYTE  ?
      wFlags        WORD  ?
      UNION
        STRUCT
          hMem        DWORD ?
          dwReserved  DWORD 4 dup(?)
        ENDS
        STRUCT
          dwCommittedSize   DWORD ?
          dwUnCommittedSize DWORD ?
          lpFirstBlock      DWORD ?
          lpLastBlock       DWORD ?
        ENDS
      ENDS
    PROCESS_HEAP_ENTRY ENDS

; 
    .data
      phe PROCESS_HEAP_ENTRY <>
    .code
; 

GetHeapEntrySize proc uses ebx edi lpData:DWORD

    mov edi, lpData
    mov phe.lpData, 0
    invoke GetProcessHeap
    mov ebx, eax
  @@:
    invoke HeapWalk, ebx, ADDR phe
    test eax, eax
    jz  @F
    .IF phe.lpData == edi
      mov eax, phe.cbData
      ret
    .ENDIF
    jmp @B
  @@:
    mov eax, -1
    ret

GetHeapEntrySize endp

; 

Probe proc pv:DWORD, cb:DWORD

  mov edx, pv
  mov eax, [edx]
  mov [edx], eax
  add edx, cb
  sub edx, 4
  mov eax, [edx]
  mov [edx], eax
  ret

Probe endp

; 
start:
; 

    mov esi, 10000000h
    .WHILE esi

      print "size "
      print uhex$(esi),13,10

      print "_Alloc return address "
      invoke _Alloc, esi
      mov ebx, eax
      print uhex$(ebx),13,10

      invoke Probe, ebx, esi
      print "Probe OK",13,10

      print "GetSize return value "
      invoke GetSize, ebx
      print uhex$(eax),13,10

      print "GetHeapEntrySize return value "
      invoke GetHeapEntrySize, ebx
      print uhex$(eax),13,10

      print "phe.wFlags (4=PROCESS_HEAP_ENTRY_BUSY) "
      movzx eax, phe.wFlags
      print uhex$(eax),13,10

      print "Realloc return address "
      mov edi, esi
      shr edi, 1
      invoke Realloc, ebx, edi
      print uhex$(eax),13,10

      invoke Probe, ebx, edi
      print "Probe OK",13,10

      print "GetSize return value "
      invoke GetSize, ebx
      print uhex$(eax),13,10

      print "GetHeapEntrySize return value "
      invoke GetHeapEntrySize, ebx
      print uhex$(eax),13,10

      print "phe.wFlags (4=PROCESS_HEAP_ENTRY_BUSY) "
      movzx eax, phe.wFlags
      print uhex$(eax),13,10

      print "CoTaskMemRealloc return address "
      shr edi, 1
      invoke CoTaskMemRealloc, ebx, edi
      print uhex$(eax),13,10

      invoke Probe, ebx, edi
      print "Probe OK",13,10

      print "GetSize return value "
      invoke GetSize, ebx
      print uhex$(eax),13,10

      print "GetHeapEntrySize return value "
      invoke GetHeapEntrySize, ebx
      print uhex$(eax),13,10

      print "phe.wFlags (4=PROCESS_HEAP_ENTRY_BUSY) "
      movzx eax, phe.wFlags
      print uhex$(eax),13,10

      print "_Free -----------",13,10
      invoke _Free, ebx

      ; -------------------------------------------------------
      ; GetSize and crt__msize generate an access violation if
      ; called on a freed memory block, but GetHeapEntrySize 
      ; just returns 0FFFFFFFFh.
      ; -------------------------------------------------------

      ;print "GetSize return value "
      ;invoke GetSize, ebx
      ;print uhex$(eax),13,10

      ;print "crt__msize return value "
      ;invoke crt__msize, ebx
      ;print uhex$(eax),13,10

      print "GetHeapEntrySize return value "
      invoke GetHeapEntrySize, ebx
      print uhex$(eax),13,10

      print "phe.wFlags (2=PROCESS_HEAP_UNCOMMITTED_RANGE) "
      movzx eax, phe.wFlags
      print uhex$(eax),13,10

      print "CoTaskMemAlloc return address "
      invoke CoTaskMemAlloc, esi
      mov ebx, eax
      print uhex$(ebx),13,10

      print "GetSize return value "
      invoke GetSize, ebx
      print uhex$(eax),13,10

      print "_Free -----------",13,10
      invoke _Free, ebx

      print "GetHeapEntrySize return value "
      invoke GetHeapEntrySize, ebx
      print uhex$(eax),13,10

      print "phe.wFlags (2=PROCESS_HEAP_UNCOMMITTED_RANGE) "
      movzx eax, phe.wFlags
      print uhex$(eax),13,10,13,10

      call wait_key
      shr esi, 1
    .ENDW

    inkey "Press any key to exit..."
    exit
; 
end start
